#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
  int n, q;
  cin >> n >> q;
  vector<int> parents(n, -1); 
  for (int i = 1; i < n; ++i) {
    cin >> parents[i];
    --parents[i];
  }
  vector<int> skills(n);
  for (int i = 0; i < n; ++i) {
    cin >> skills[i];
    --skills[i];
  }
  vector<int> queries(q); 
  for (int i = 0; i < q; ++i) {
    cin >> queries[i];
    --queries[i];
  }

  vector<vector<int>> graph(n); 
  for (int i = 1; i < n; ++i) {
    graph[parents[i]].push_back(i);
  }

  auto simulate_full_order = [n, &graph](const vector<int> &skills) {
    priority_queue<pair<int, int>> pq;
    pq.emplace(skills[0], 0);
    vector<int> positions(n); 
    vector<int> order;
    order.reserve(n);
    int ptr = 0; 
    while (!pq.empty()) {
      int u = pq.top().second;
      pq.pop();
      positions[u] = ptr++;
      order.push_back(u);
      for (auto v : graph[u]) {
        pq.emplace(skills[v], v);
      }
    }
    return make_pair(order, positions);
  };

  vector<int> answers(q, n);

  for (int change = 0; change < n; ++change) {
    int old_skills = skills[change]; 
    skills[change] = -1; 
    auto positions = simulate_full_order(skills).second; 
    for (int qr_id = 0; qr_id < q; ++qr_id) {
      int u = queries[qr_id];
      answers[qr_id] = min(answers[qr_id], positions[u]);
    }
    skills[change] = old_skills;
  }

  for (int qr_id = 0; qr_id < q; ++qr_id) {
    cout << answers[qr_id] << ' ';
  }
}
