#include <iostream>
#include <vector>
#include <map>
#include <assert.h>
#include <set>
#include <algorithm>

using namespace std;

const long long inf = 1e18;
const int MAXN = 1 << 19;
int tin[MAXN];
int tout[MAXN];
int h[MAXN];
int h1[MAXN];
int parent[MAXN];
int timer = 0;

void dfs(int v, vector<vector<int>> &g, vector<int> &p) {
    tin[v] = timer++;
    for (int u : g[v]) {
        if (p[v] == -1 || g[p[v]].size() > 1 || g[v].size() > 1) {
            parent[u] = v;
            h[u] = h[v] + 1;
        } else {
            parent[u] = parent[v];
            h[u] = h[v];
        }
        h1[u] = h1[v] + 1;
        dfs(u, g, p);
    }
    tout[v] = timer;
}

int tree[MAXN * 2];

void upd(int i, int x) {
    i += MAXN;
    tree[i] = x;
    while (i > 1) {
        i >>= 1;
        tree[i] = tree[i * 2] + tree[i * 2 + 1];
    }
}

void upd1(int i, int x) {
    i += MAXN;
    tree[i] += x;
    while (i > 1) {
        i >>= 1;
        tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
    }
}

int get(int l, int r) {
    int ans = 0;
    l += MAXN;
    r += MAXN;
    while (l < r) {
        if (l & 1) {
            ans += tree[l++];
        }
        if (r & 1) {
            ans += tree[--r];
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

int get1(int l, int r) {
    int ans = 0;
    l += MAXN;
    r += MAXN;
    while (l < r) {
        if (l & 1) {
            ans = max(ans, tree[l++]);
        }
        if (r & 1) {
            ans = max(ans, tree[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

bool is_anc(int x, int y) {
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

int pos = -1;
int res[MAXN];
int sum[MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> p(n, -1);
    parent[0] = -1;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    vector<int> s(n);
    for (int& i : s) cin >> i;
    vector<int> queries(q);
    for (int& i : queries) {
        cin >> i;
    }
    vector<int> ord;
    set<pair<int, int>> setik{{-s[0], 0}};
    while (ord.size() != n) {
        ord.push_back(setik.begin()->second);
        setik.erase(setik.begin());
        for (int u : g[ord.back()]) {
            setik.insert({ -s[u], u });
        }
    }
    vector<int> rev(n);
    for (int i = 0; i < n; ++i) {
        rev[ord[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end(), [&] (int x, int y) {
            return rev[x] < rev[y];
        });
    }
    dfs(0, g, p);
    int mh = *max_element(h, h + n);
    int pos = 0;
    vector<bool> need(n, false);
    for (int i : queries) {
        need[i - 1] = true;
    }
    for (int v : ord) {
        if (mh > 110) {
            upd(tin[v], 1);
        } else {
            int u = v;
            while (u != -1) {
                upd1(tin[u], 1);
                u = parent[u];
            }
        }
        if (need[v]) {
            int ans = 0;
            int u = parent[v];
            int pr = v;
            while (u != -1) {
                if (mh > 110) {
                    for (int w : g[u]) {
                        if (!is_anc(w, v)) {
                            ans = max(ans, get(tin[w], tout[w]));
                        }
                    }
                } else {
                    if (h1[pr] != h1[u] + 1) {
                        pr = u;
                        u = parent[u];
                        continue;
                    }
                    int t = pr;
                    int L = tin[t], R = tout[t];
                    ans = max(ans, max(get1(tin[u] + 1, L), get1(R, tout[u])));
                }
                pr = u;
                u = parent[u];
            }
            res[v] = pos - ans;
        }
        ++pos;
    }
    for (int i : queries) {
        cout << res[i - 1] << ' ';
    }
}
/*
 5 4
 1 2 2 1
 3 5 1 2 4
 5 3 1 4
 */
