#include <bits/stdc++.h>

struct ST {
    struct Data {
        int max, dlt;
        Data(int val = -0) : max(val), dlt(0) { ; }
    };

    size_t size;
    std::vector<Data> data;

    void upd(int i, int dlt) {
        data[i].max += dlt;
        data[i].dlt += dlt;
    }

    void push(int i) {
        if (data[i].dlt != 0) {
            upd(2 * i, data[i].dlt);
            upd(2 * i + 1, data[i].dlt);
            data[i].dlt = 0;
        }
    }

    void merge(int i) {
        data[i].max = std::max(data[2 * i].max, data[2 * i + 1].max);
    }

    ST(size_t n) {
        size = std::bit_ceil(n);
        data.assign(size * 2, Data());
    }

    void aux_update(int i, int l, int r, int ql, int qr, int dlt) {
        if (qr <= l || r <= ql) {
            return;
        } else if (ql <= l && r <= qr) {
            upd(i, dlt);
        } else {
            push(i);
            aux_update(2 * i, l, l + r >> 1, ql, qr, dlt);
            aux_update(2 * i + 1, l + r >> 1, r, ql, qr, dlt);
            merge(i);
        }
    }

    void update(int l, int r, int dlt) {
        aux_update(1, 0, size, l, r, dlt);
    }

    // int aux_get(int i, int l, int r, int ql, int qr) {
    //     if (qr <= l || r <= ql) {
    //         return -1e9;
    //     } else if (ql <= l && r <= qr) {
    //         return data[i].max;
    //     } else {
    //         push(i);
    //         return std::max(aux_get(2 * i, l, l + r >> 1, ql, qr), aux_get(2 * i + 1, l + r >> 1, r, ql, qr));
    //     }
    // }

    // int get(int l, int r) {
    //     return aux_get(1, 0, size, l, r);
    // }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, q;
    std::cin >> n >> q;
    std::vector<int> prev(n, -1);
    for (int i = 1; i < n; i++) {
        std::cin >> prev[i], prev[i]--;
    }
    std::vector<int> input(n);
    for (auto& i : input) {
        std::cin >> i;
    }

    std::vector<int> sz(n, 1);
    for (int i = n - 1; i > 0; i--) {
        sz[prev[i]] += sz[i];
    }
    std::vector<std::vector<int>> gr(n);
    for (int i = 1; i < n; i++) {
        gr[prev[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        std::sort(gr[i].begin(), gr[i].end(), [&](int a, int b) { return sz[a] > sz[b]; });
    }

    std::vector<int> eul, tin(n), tout(n), depth(n), jump(n);

    [&](this auto dfs, int v, int j) -> void {
        tin[v] = eul.size(), jump[v] = j;
        eul.push_back(v);
        for (int t : gr[v]) {
            depth[t] = depth[v] + 1;
            dfs(t, t == gr[v].front() ? j : t);
        }
        tout[v] = eul.size();
    }(0, 0);

    ST st(n);

    auto hld_apply = [&](int v, auto f) {
        while (v != -1) {
            int u = jump[v];
            f(tin[u], tin[v] + 1);
            v = prev[u];
        }
    };

    std::vector<int> ans(n);

    std::priority_queue<std::pair<int, int>> heap;
    heap.push({input[0], 0});
    int cnt = 0;
    while (heap.size()) {
        auto [skill, v] = heap.top();
        heap.pop();

        hld_apply(v, [&](int l, int r) {
            st.update(l, r, -int(1e9));
        });
        // int max_dlt = std::max(0, st.get(0, n));
        int max_dlt = std::max(0, st.data[1].max);
        ans[v] = cnt - max_dlt;

        hld_apply(v, [&](int l, int r) {
            st.update(l, r, 1 + int(1e9));
        });

        cnt += 1;
        for (int t : gr[v]) {
            heap.push({input[t], t});
        }
    }

    for (int i = 0; i < q; i++) {
        int v;
        std::cin >> v, v--;
        std::cout << ans[v] << " \n"[i + 1 == q];
    }

    return 0;
}
