#include <bits/stdc++.h>

using namespace std;

const int INF = (int)1e9 + 7;

vector<int> p;
vector<vector<int>> gr;
vector<int> s, ans;

vector<int> build_order() {
    vector<int> order;
    priority_queue<pair<int, int>> cands;
    cands.emplace(s[0], 0);
    while (!cands.empty()) {
        int root = cands.top().second;
        cands.pop();
        for (int i : gr[root]) {
            cands.emplace(s[i], i);
        }
        order.push_back(root);
    }
    return order;
}

struct SegmentTree {
    struct Node {
        int max, add = 0;
    };

    int sz, n;
    vector<Node> tree;

    void update(int t) {
        tree[t].max = max(tree[t * 2].max + tree[t * 2].add, tree[t * 2 + 1].max + tree[t * 2 + 1].add);
    }

    void set_push(int t, int value) {
        tree[t].add += value;
    }

    void init(int new_n) {
        n = new_n;
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz, {0, 0});
    }

    void add_impl(int t, int tl, int tr, int left, int right, int value) {
        if (left >= right) {
            return;
        }
        if (tl == left && tr == right) {
            set_push(t, value);
            return;
        }
        int mid = (tl + tr) / 2;
        add_impl(t * 2, tl, mid, left, min(right, mid), value);
        add_impl(t * 2 + 1, mid, tr, max(left, mid), right, value);
        update(t);
    }

    void add_value(int left, int right, int value) {
        add_impl(1, 0, sz, left, right, value);
    }

    int get_max_impl(int t, int tl, int tr, int left, int right) {
        if (left >= right) {
            return -INF;
        }
        if (tl == left && tr == right) {
            return tree[t].max + tree[t].add;
        }
        int mid = (tl + tr) / 2;
        return max(get_max_impl(t * 2, tl, mid, left, min(right, mid)),
                   get_max_impl(t * 2 + 1, mid, tr, max(left, mid), right)) + tree[t].add;
    }

    int get_max(int left, int right) {
        return get_max_impl(1, 0, sz, left, right);
    }
};

struct HLD {
    int n;
    vector<vector<int>> gr;
    vector<int> sz;
    vector<int> top, tin;

    void dfs_sz(int v) {
        sz[v] = 1;
        for (int u : gr[v]) {
            sz[v] += sz[u];
        }
    }

    int timer = 0;
    void dfs_hld(int v, int new_top) {
        top[v] = new_top;
        tin[v] = timer++;
        for (int i = 0; i < (int)gr[v].size(); ++i) {
            if (sz[gr[v][i]] > sz[gr[v][0]]) {
                swap(gr[v][i], gr[v][0]);
            }
        }
        for (int i = 0; i < (int)gr[v].size(); ++i) {
            dfs_hld(gr[v][i], (i == 0 ? new_top : gr[v][i]));
        }
    }

    SegmentTree tree;

    HLD(const vector<vector<int>>& gr): n((int)gr.size()), gr(gr) {
        sz.resize(n);
        dfs_sz(0);
        top.resize(n), tin.resize(n);
        dfs_hld(0, 0);
        tree.init(n);
    }

    vector<pair<int, int>> segs;
    int add_vertex(int v) {
        segs.clear();
        segs.emplace_back(n, n);
        segs.emplace_back(tin[v], tin[v] + 1);
        tree.add_value(tin[v], tin[v] + 1, 1);
        while (v != 0) {
            if (top[v] != v) {
                segs.emplace_back(tin[top[v]], tin[v]);
                tree.add_value(tin[top[v]], tin[v], 1);
                v = top[v];
            } else {
                v = p[v];
                segs.emplace_back(tin[v], tin[v] + 1);
                tree.add_value(tin[v], tin[v] + 1, 1);
            }
        }
        segs.emplace_back(0, 0);
        reverse(segs.begin(), segs.end());
        int max_value = 0;
        for (int i = 0; i + 1 < (int)segs.size(); ++i) {
            max_value = max(max_value, tree.get_max(segs[i].second, segs[i + 1].first));
        }
        return max_value;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    p.resize(n);
    p[0] = 0;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        gr[p[i]].push_back(i);
    }
    s.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    ans.resize(n);
    auto order = build_order();

    HLD hld(gr);
    for (int i = 0; i < n; ++i) {
        int v = order[i];
        int max_value = hld.add_vertex(v);
        ans[v] = i - max_value;
    }

    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        --v;
        cout << ans[v] << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    solve();
}

