#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
  int n, q;
  cin >> n >> q;
  vector<int> parents(n, -1); 
  for (int i = 1; i < n; ++i) {
    cin >> parents[i];
    --parents[i];
  }
  vector<int> skills(n);
  for (int i = 0; i < n; ++i) {
    cin >> skills[i];
    --skills[i];
  }
  vector<int> queries(q); 
  for (int i = 0; i < q; ++i) {
    cin >> queries[i];
    --queries[i];
  }

  vector<vector<int>> graph(n); 
  for (int i = 1; i < n; ++i) {
    graph[parents[i]].push_back(i);
  }

  auto simulate_order = [n, &graph](int target, const vector<int> &skills) -> int {
    priority_queue<pair<int, int>> pq;
    pq.emplace(skills[0], 0);
    int position = 0;
    while (!pq.empty()) {
      int u = pq.top().second;
      if (u == target) {
        break;
      }
      pq.pop();
      ++position; 
      for (auto v : graph[u]) {
        pq.emplace(skills[v], v);
      }
    }
    return position; 
  };

  vector<int> answers(q, n);

  for (int qr_id = 0; qr_id < q; ++qr_id) {
    int target = queries[qr_id];
    int& qr_ans = answers[qr_id];
    for (int change = 0; change < n; ++change) {
      int old_skills = skills[change];
      skills[change] = -1;
      qr_ans = min(qr_ans, simulate_order(target, skills));
      skills[change] = old_skills;
    }
  }

  for (int qr_id = 0; qr_id < q; ++qr_id) {
    cout << answers[qr_id] << ' ';
  }
}
